#
# Makefile Template for Tessy
#
# Compiler   : IAR iccm16c
# Environment: IAR C-SPY
# Template Version : 1
#

# Defines to be generated by Tessy:
#
# TESSY_SYS          :=
# MODULE_PATH        :=
# TESTOBJECT         :=
# USER_LINK_OPTIONS  :=
# COMPILER_INSTALL_PATH :=
# TARGET_INSTALL_PATH   :=

#####################################################################
#BEGIN_DEFINES
#####################################################################


TESSY_SYS_DOS   := $(shell ts_pathname -s $(TESSY_SYS))
MODULE_PATH_DOS := $(shell ts_pathname -s $(MODULE_PATH))
IAR_HOME        := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')

all    : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.d34

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE := $(TESSY_SYS)/make/master_cspy_gnu_i386.mk
S_COMM_MAKE := $(TESSY_SYS)/src/comm/comm_cspy_iar_m16c.mk


#
# SLAVE
# (You may change these settings to use your own compiler/linker options)
#
S_COMP_OPTIONS := --cpu=$(CPU) --data_model=near --calling_convention=normal --variable_data=near --constant_data=near \
                 --dlib_config "$(CONFIG_HEADER)" -On --no_cse --no_unroll --no_inline --no_code_motion --no_tbaa \
                 --code_segment=CODE --debug -e --align_func 1 -D TESSY -D TS_SLAVE -D TS_CSPY -D TS_M16C -D TS_HAVE_FLOAT32

S_LINK_OPTIONS := -w -I$(IAR_HOME)\lib\ -f "$(LINKER_CMD)" -rt -s __program_start -D_CSTACK_SIZE=1000 \
                  -D_ISTACK_SIZE=100 -D_DATA16_HEAP_SIZE=1000 -D_FAR_HEAP_SIZE=1000 -D_DATA20_HEAP_SIZE=1000 "$(LIBRARY)"

S_INCLUDES     := -I$(IAR_HOME)\inc\ -I$(IAR_HOME)\inc\dlib -I$(IAR_HOME)\lib\dlib -I$(TESSY_SYS_DOS)\include\tessy\comm\ -I$(MODULE_PATH_DOS)\

S_CC           := $(IAR_HOME)\bin\iccm16c
S_LINK         := $(IAR_HOME)\bin\xlink
S_OBJECTS      := $(MODULE_PATH_DOS)\tslows_cspy.r34 \
                  $(MODULE_PATH_DOS)\tstcomm.r34 \
                  $(MODULE_PATH_DOS)\tscoml.r34
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.r34
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.r34

#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH)/ts_src01.o ... ts_srcnn.o
# USER_COMP_OPTIONS* :=
#
# $(MODULE_PATH)/ts_src*.o : $(MODULE_PATH)/ts_src*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS*) $<

#####################################################################
#BEGIN_TARGETS
#####################################################################


# Don't show action lines
# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<

#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)


#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r34 : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<


$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.d34 : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r34 \
															$(S_SRC_OBJECTS) \
															$(S_UC_OBJECT) \
															$(S_STUB_OBJECT) \
															$(S_OBJECTS)
	@echo *
	@echo ***** Linking Slave *****
	$(S_LINK) $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r34 $(S_STUB_OBJECT) $(S_UC_OBJECT) \
   $(S_SRC_OBJECTS) $(USER_LINK_OPTIONS) $(S_OBJECTS) -o "$@" $(S_LINK_OPTIONS)
	@-ts_rm "$(MODULE_PATH)"/*.r34


#####################################################################
#END_TARGETS
#####################################################################












